/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import java.awt.Point;

/**
 *
 * @author kosen
 */
@JsonIgnoreProperties({"x", "y"})
public class OkotoPlace extends Point{
    
    @JsonCreator
    public OkotoPlace(@JsonProperty("lineNumber") int line, @JsonProperty("columnNumber") int column) {
        super(line,column);
    }
    
    public int getLineNumber(){
        return this.x;
    }
    
    public int getColumnNumber(){
        return this.y;
    }
    
}
