/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

/**
 *
 * @author t-koji
 */
public class SelecTableLabel extends JLabel{
    public static Color selectedColor = Color.BLUE;
    
    private Color color;
    private boolean isSelected;
    
    public SelecTableLabel(Color mycolor,boolean selected){
        super();
        this.setHorizontalAlignment(SwingConstants.CENTER);
        this.color = mycolor;
        this.isSelected = selected;
    }
    
    public void setSelected(boolean selected){
        this.isSelected = selected;
    }
    
    public boolean isSelected(){
        return this.isSelected;
    }
    
    
    @Override
    public void paint(Graphics g){
        if(this.isSelected){
            g.setColor(selectedColor);
        } else {
            g.setColor(Color.black);
        }
        g.fillRect(0, 0, this.getSize().width, this.getSize().height);
        g.setColor(this.color);
        g.fillRect(5, 5, this.getSize().width-10, this.getSize().height-10);
        super.paint(g);
        
    }
    
    public Color getColor(){
        return this.color;
    }
    
    
}
