/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package syousyohenkan;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author kosen
 */
public class SyousyoHenkan {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String path = "C:\\Users\\kosen\\Desktop\\国語研科研用データ\\尚書プレーンテキスト\\変換前データ";
//        File baseFile = new File(path + File.separator + "尚書巻1-3春_181029.txt");
//        File newFile = new File(path + File.separator + "..\\尚書巻1-3春_181029統計_format.txt");
        File baseFile = new File(path + File.separator + "尚書巻1-3春_181228.txt");
        File newFile = new File(path + File.separator + "..\\尚書巻1-3春_181228.txt_format.txt");
//        File baseFile = new File(path + File.separator + "尚書巻7-9秋_181029.txt");
//        File newFile = new File(path + File.separator + "..\\尚書巻7-9秋_181029統計_format.txt");
        Pattern baseNameLine = Pattern.compile("\\uFEFF?（(.*)）");
        Pattern check = Pattern.compile(".*?\\p{InHiragana}.*?");
        Pattern check2 = Pattern.compile(".*?\\p{InKatakana}.*?");
        DecimalFormat twodec = new DecimalFormat("00");
        boolean inWariTyu = false;
        HashMap<String,Integer> toukei = new HashMap<String,Integer>();
        toukei.put("nomal", 0);
        toukei.put("wari", 0);

        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(baseFile)));
            PrintWriter writer = new PrintWriter(new OutputStreamWriter(new FileOutputStream(newFile)));
            String Line;
            
            String base = "";
            int lineNumber=1;
            while((Line = reader.readLine()) != null){
                int nomalC = 0;
                int wariC = 0;
                Matcher mc = baseNameLine.matcher(Line);
                if(mc.matches()){
                    base=mc.group(1);
                    lineNumber=1;
                } else {
                    String index = base + twodec.format(lineNumber) + ":";
                    writer.print(index);
                    //バグ探し
                    if(check.matcher(Line).matches()){
                        System.out.println(Line);
                    }
                    if(check2.matcher(Line).matches()){
                        System.out.println(Line);
                    }
                    
                    if(inWariTyu){
                        writer.print("［");
                    }
                    for(char c:Line.toCharArray()){
                        String moji = Character.toString(c);
                        if(moji.equals("［")){
                            inWariTyu = true;
                        } else if(moji.equals("］")){
                            inWariTyu = false;
                        } else {
                            if(inWariTyu){
                                if(!moji.equals("／")){
                                    wariC++;
                                }
                            } else {nomalC++;}
                        }
                        writer.print(moji);
                    }
                    if(inWariTyu){
                        writer.print("］");
                    }
                    writer.println();
                    
                    //文字数のエラーを考える処理
                    toukei.put("nomal", toukei.get("nomal") + nomalC);
                    toukei.put("wari", toukei.get("wari") + wariC);
                    if((nomalC+wariC/2) > 18){
                        System.out.println(index+"が長すぎる？"+Line);
                    }
                    lineNumber++;
                }
            }
            reader.close();
            writer.flush();
            writer.close();
        } catch (FileNotFoundException ex) {
            Logger.getLogger(SyousyoHenkan.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(SyousyoHenkan.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        System.out.println("統計結果");
        System.out.println("文字数");
        System.out.println("本文："+toukei.get("nomal")+"割注："+toukei.get("wari"));
        
    }
    
}
