package main;


import java.awt.Font;
import java.awt.FontFormatException;
import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import okototentest.OkotoKigouSet;
import okototentest.gui.OkotoInputForm;
import java.awt.GraphicsEnvironment;
/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author kosen
 */
public class bootstrap {
    public static final String title = "移点支援システム　プロトタイプ版 2019.04.09 v1.2";
    public static Font CharFont;
    public static Font ButtonFont;
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            //明朝体フォントの読み込みとセット
            File minfont = new File("ipam.ttf");
            if(minfont.exists()){
                CharFont = Font.createFont(Font.TRUETYPE_FONT, minfont);
                GraphicsEnvironment.getLocalGraphicsEnvironment().registerFont(CharFont);
                System.out.println(CharFont.getName() + " was read.");
            }
            //ゴシック体フォントの読み込みとセット
            File gfont = new File("ipag.ttf");
            if(gfont.exists()){
                ButtonFont = Font.createFont(Font.TRUETYPE_FONT, gfont);
                GraphicsEnvironment.getLocalGraphicsEnvironment().registerFont(ButtonFont);
                System.out.println(ButtonFont.getName() + " was read.");
            }
            
        } catch (FontFormatException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(bootstrap.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            Logger.getLogger(bootstrap.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(bootstrap.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedLookAndFeelException ex) {
            Logger.getLogger(bootstrap.class.getName()).log(Level.SEVERE, null, ex);
        }
        try {
            OkotoKigouSet.readDataFile(new File("wokotomoji.txt"));
        } catch (IOException ex) {
            Logger.getLogger(bootstrap.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
        
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                OkotoInputForm form = new OkotoInputForm();
                form.setTitle(title);    
                form.setVisible(true);
                
                //MojiTablePanel.sampleBoot();
                
            }
        });
    }    
}
