/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import okototentest.OkotoKigouSet;
import static okototentest.gui.OkotoInputDialog.BUTTONFONTSIZE;

/**
 *
 * @author kosen
 */
public class KigouSentakuDialog extends javax.swing.JDialog {

    String SelectedKigou;
    Frame _parent;

    /**
     * Creates new form KigouSentakuDialog
     */
    public KigouSentakuDialog(java.awt.Frame parent) {
        super(parent, true);
        _parent = parent;
        initComponents();
        refleshKigouTable();
    }

    public void refleshKigouTable() {
        int columnCount = 5;
        String[] kigouList = OkotoKigouSet.getElements();
        int rowCount = kigouList.length / columnCount;
        if (kigouList.length % columnCount != 0) {
            rowCount++;
        }

        this.jPanel1.removeAll();
        this.jPanel1.setLayout(new GridLayout(rowCount, columnCount));
        for (int i = 0; i < kigouList.length; i++) {
            JButton kigouSelectButton = new JButton(kigouList[i]);
            if (kigouList[i].equals(this.SelectedKigou)) {
                kigouSelectButton.setBackground(SelecTableLabel.selectedColor);
            }
            kigouSelectButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    KigouSentakuDialog.this.kigouButtonClicked((JButton) e.getSource());
                }
            });
            //ボタンの文字サイズを指定
            Font baseFont = main.bootstrap.ButtonFont.deriveFont(Font.PLAIN, BUTTONFONTSIZE);
            kigouSelectButton.setFont(baseFont);
            //

            this.jPanel1.add(kigouSelectButton);
        }
        this.validate();
        this.repaint();
    }

    /**
     * 記号選択ボタンがクリックされれると呼び出される
     */
    public void kigouButtonClicked(JButton button) {
        SelectedKigou = button.getText();
        this.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 248, Short.MAX_VALUE)
        );

        jButton1.setText("記号をさらに追加");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 243, Short.MAX_VALUE)
                        .addComponent(jButton1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        CharInputDialog cin = new CharInputDialog(this._parent, true);
        cin.setVisible(true);
        String addString = cin.getInputString();
        if (addString != null) {
            OkotoKigouSet.addNewString(addString);
            try {
                OkotoKigouSet.saveFile();
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this, "ヲコト点文字ファイルに書き込みが失敗しました", "FileWtireError", JOptionPane.ERROR_MESSAGE);
            }
        }
        this.refleshKigouTable();

    }//GEN-LAST:event_jButton1ActionPerformed

    public String getSelectedKigou(){
        return this.SelectedKigou;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
}
