/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Point;
import java.util.ArrayList;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.JTable;

/**
 *
 * @author ktajima
 */
public class TableCellRendererFillColors extends DefaultTableCellRenderer {
    public static Color fillColor = new Color(255,0,0,50);
    public static Color SelectColor = new Color(0,0,255,100);
    private ArrayList<Point> fillCells;
    
    public TableCellRendererFillColors(){
        super();
        this.fillCells = new ArrayList<Point>();
        //dummy
        //this.fillCells.add(new Point(3,3));
        //this.fillCells.add(new Point(3,5));
        //this.fillCells.add(new Point(10,3));
    }
    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
        
        Point mypoint = new Point(row,column);
        if(isSelected){
            this.setBackground(SelectColor);
        } else if(fillCells.contains(mypoint)) {
            this.setBackground(fillColor);
        } else {
            this.setBackground(table.getBackground());
        }
        
        return this;
    }
    
    public void addFillPoints(ArrayList<Point> points){
        this.fillCells = points;
    }
    
    public void addFillPoint(int row,int column){
        this.fillCells.add(new Point(row,column));
    }
    
    public void removePoint(int row,int column){
        Point mypoint = new Point(row,column);
        if(this.fillCells.contains(mypoint)){
            this.fillCells.remove(mypoint);
        }
    }
}
